app.controller('MainCtrl', MainCtrl);

function MainCtrl ($scope, $uibModal, sampleService, programService) {
	
	var self = this;
	
	self.flashSize = 8388608;
	self.totalSize = 4096;
	
	// Sample progress bar
	self.sampleMax = 64;
	self.sampleValue = 0;
	
	// Memory progress bar
	self.memoryMax = (self.flashSize/1000000).toFixed(2);
	self.memoryValue = 0;

	
	self.status = "hello world";
	
	self.sampleArray = [];


	// DEVELOPER!
	self.dev = false;
	self.samplePack = []
	
	// Sample Packs
	self.selectedSampleSet = null;
	self.sampleSets  = [];

	self.progState = false;


	self.sampleSetLabel = 'Loading...';


	self.version = "";




self.GetAppVersion = function()
{
	var manifest = chrome.runtime.getManifest();
	var version = manifest.version.split('.');
	var versionMajor = parseInt(version[0]);
	var versionMinor = parseInt(version[1]);
	var versionMinor2 = parseInt(version[2]);

	self.version = versionMajor + "." + versionMinor + "." + versionMinor2;
}

self.GetAppVersion();




	// Find Erica Programmer and Connect to Device
	programService.FindProgrammer(function(err) {
		if(err) {
			console.log(err);
			self.status = 'Erica Synths Programmer not connected!'
			self.progState = false;
		} else {
			self.status = 'Erica Synths Programmer connected!'
			self.progState = true;

			// // Try to connect to the Drum Module
			// setTimeout(function() {
			// 	programService.ConnectToDevice(function(err) {
			// 		if(err) {
			// 			self.status = 'Could not connect to Erica Synths Pico Drum!'
			// 		}
			// 		else {
			// 			self.status = 'Erica Synths Pico Drum connected!'
			// 		}

			// 		$scope.$apply();
			// 	});
			// }, 1000);
		}

		$scope.$apply();
	});




	// Get Sample List
	sampleService.GetSamplePackList(function(err, list) {
		if(err) {
			console.log(err);
			self.sampleSetLabel = 'No sample pack';
		} else {
			self.sampleSets = list;
			self.sampleSetLabel = 'Choose sample pack';
		}
		$scope.$applyAsync();
	});



	
	// Delete a sample
	self.Delete = function(index) {

		self.totalSize -= self.sampleArray[index].buffer.byteLength;
		self.memoryValue = (self.totalSize / 1000000).toFixed(2);
		self.sampleValue--;

		self.sampleArray.splice(index, 1);
		// DEVELOPER!
		if(self.dev)
			self.samplePack.splice(index, 1);
	}


	self.DeleteAll = function() {
		self.totalSize = 4096;
		self.memoryValue = (self.totalSize / 1000000).toFixed(2);
		self.sampleValue = 0;

		self.sampleArray = [];
		// DEVELOPER!
		if(self.dev)
			self.samplePack = [];
	}


	self.Load = function()
	{

		if(self.dev) {
			var file = new File();
			file.Write('sample_pack', msgpack.encode(self.samplePack), function() {

			});
		}

		// console.log(self.samplePack[0].data.byteLength);
		// var pack = msgpack.encode(self.samplePack);
		// console.log(pack);
		// var unpack = msgpack.decode(pack);
		// console.log(unpack);

		

		if(self.selectedSampleSet !== null) {

			// console.log(Object.getOwnPropertyNames(self.selectedSampleSet).length);

			self.DeleteAll();

			sampleService.DownloadSamplePack(self.selectedSampleSet.file, function(err, data) {
				if(err)
					console.log(err);
				else {
					console.log('Decoding sample pack...');

					self.AddSamplesFromPack(msgpack.decode(new Uint8Array(data)), 0, function(err){
						if(err)
							console.log(err);
					});
				}

			});
		}
	}


	self.Play = function($event, index) {
		var el = angular.element(event.target);

		if(el.html() == 'Play') {
			el.html('Stop');
			el.addClass('btn-warning');
			el.removeClass('btn-success');

			sampleService.Play(self.sampleArray[index].data, function() {
				el.html('Play');
				el.addClass('btn-success');
				el.removeClass('btn-warning');
			});
		} else {
			sampleService.Stop();
		}
	}

	self.Program = function() {

		if(self.sampleArray.length == 0) {
			self.OpenMsgModal('No samples in list!');
		} else if (!self.progState) {
			self.OpenMsgModal('Erica Synths Programmer not connected!');
		} else {
			self.OpenProgramModal();
		}

	}




	self.AddSamplesFromPack = function(samplePack, sampleIdx, callback) {
		var sample = samplePack[sampleIdx];

		sampleService.Decode(sample.data, function(err, data) {
			if(err)
				return (typeof callback === 'function' && callback(err));

			// Convert data to binary format
			sampleService.Convert(data, function(err, sampleBuffer) {
				if(err)
					return (typeof callback === 'function' && callback(err));
				else {

					var sampleBinarySize = sampleBuffer.byteLength/1000;
					var samplePercentSize =  sampleBuffer.byteLength/self.flashSize * 100;
					var entryLabel = sample.name + ' ['+ sampleBinarySize.toFixed(2) +' kb, '+ samplePercentSize.toFixed(2) +'%]';

					if(self.sampleValue == 64) {
						console.log('All slots taken!');
						self.OpenMsgModal('Sample list is full!');
						return (typeof callback === 'function' && callback(null));
					} else if((self.totalSize + sampleBuffer.byteLength) > self.flashSize) {
						console.log('No more memory!');
						self.OpenMsgModal('Memory is full!');
						return (typeof callback === 'function' && callback(null));
					}

					// Increase total size
					self.totalSize += sampleBuffer.byteLength;
					self.memoryValue = (self.totalSize / 1000000).toFixed(2);
					self.sampleValue++;

					self.sampleArray.push({
						name : sample.name,
						size: sampleBinarySize.toFixed(2),
						sizep: samplePercentSize.toFixed(2),
						data : data,
						buffer: sampleBuffer,
					});
				
					$scope.$applyAsync();
				}

				// Increase sample idx
				sampleIdx++;
				if(sampleIdx == samplePack.length)
					typeof callback === 'function' && callback(null);
				else {
					// Add next sample
					self.AddSamplesFromPack(samplePack, sampleIdx, callback);
				}
			});
		});
	}



	self.AddSample = function(entries, entryIdx, callback) {

		var entry = entries[entryIdx];

		if(entry.isFile) {

			sampleService.Open(entry, function(err, rawData) {

				if(err) {
					console.log(entry, err);

					// Go To next file
					entryIdx++;
					if(entryIdx == entries.length)
						typeof callback === 'function' && callback(null);
					else {
						// Add next sample
						self.AddSample(entries, entryIdx, callback);
					}
				}
				else {

					var raw = rawData.slice(0);


					sampleService.Decode(rawData, function(err, data) {

						if(err) {
							console.log(entry, err);

							// Go To next file
							entryIdx++;
							if(entryIdx == entries.length)
								typeof callback === 'function' && callback(null);
							else {
								// Add next sample
								self.AddSample(entries, entryIdx, callback);
							}
						} else {


							console.log(entry.name, data);


							// Convert data to binary format
							sampleService.Convert(data, function(err, sampleBuffer) {
								if(err)
									console.log(err);
								else {

									var sampleBinarySize = sampleBuffer.byteLength/1000;
									var samplePercentSize =  sampleBuffer.byteLength/self.flashSize * 100;
									var entryLabel = entry.name + ' ['+ sampleBinarySize.toFixed(2) +' kb, '+ samplePercentSize.toFixed(2) +'%]';


									if(self.sampleValue == 64) {
										console.log('All slots taken!');
										self.OpenMsgModal('Sample list is full!');
										return (typeof callback === 'function' && callback(null));
									} else if((self.totalSize + sampleBuffer.byteLength) > self.flashSize) {
										console.log('No more memory!');
										self.OpenMsgModal('Memory is full!');
										return (typeof callback === 'function' && callback(null));
									}


									// Increase total size
									self.totalSize += sampleBuffer.byteLength;
									self.memoryValue = (self.totalSize / 1000000).toFixed(2);
									self.sampleValue++;

									self.sampleArray.push({
										name : entry.name,
										size: sampleBinarySize.toFixed(2),
										sizep: samplePercentSize.toFixed(2),
										data : data,
										buffer: sampleBuffer,
									});

									// DEVELOPER!
									if(self.dev) {
										self.samplePack.push({
											name : entry.name,
											data : raw
										});
									}

									$scope.$apply();
								}

								// Increase entry idx
								entryIdx++;
								if(entryIdx == entries.length)
									typeof callback === 'function' && callback(null);
								else {
									// Add next sample
									self.AddSample(entries, entryIdx, callback);
								}
							});
						}
					});
				}
			});
		} else if(entry.isDirectory) {

			console.log('Directory: ', entry.name);

			var dirReader = entry.createReader();

			dirReader.readEntries(function(results) {

				// for(var j=0; j<results.length; j++) {
				// 		if(results[j].isFile) {
				// 			 console.log(results[j].name);	
				// 			//self.AddSample(results[j]);
				// 		}
				// 	}

				self.AddSamples(results, function(err){
					if(err)
						return (typeof callback === 'function' && callback(err));

					typeof callback === 'function' && callback(null);
				});		
			});
		}
	}


	self.AddSamples = function(entries, callback) {

		self.AddSample(entries, 0, function(err) {
			if(err)
				return (typeof callback === 'function' && callback(err));

			typeof callback === 'function' && callback(null);
		});
	}



	self.Browse = function() {
		chrome.fileSystem.chooseEntry({
			type : "openFile",
			accepts : [ { extensions: ["wav"] } ],
			acceptsMultiple : true
		}, function(entry) {

			if(chrome.runtime.lastError) {
				console.log(chrome.runtime.lastError.message);
			} else {
				self.AddSamples(entry, function(err) {
					if(err)
						console.log('Failed to add sample files!');

					console.log('Files added!');
				});
			}
		});
	}

	
	
	self.DropEvent = function(args) {
		console.log('Drop happened');

		var length = args.length;
		var entries = [];

		for (var i = 0; i < length; i++) {
			entries.push(args[i].webkitGetAsEntry());
		}

		self.AddSamples(entries, function(err) {
			if(err)
				console.log('Failed to add sample files!');

			console.log('Files added!');
		});
		
		// for (var i = 0; i < length; i++) {
		// 	var entry = args[i].webkitGetAsEntry();
			
		// 	if (entry.isFile) {

		// 		self.AddSample(entry);

		// 	} else if (entry.isDirectory) {
		// 		var dirReader = entry.createReader();

		// 		dirReader.readEntries(function(results) {
						
		// 			for(var j=0; j<results.length; j++) {
		// 				if(results[j].isFile) {
		// 					// console.log(results[j].name);	
		// 					self.AddSample(results[j]);
		// 				}
		// 			}
		// 		});
		// 	}
		// }
	}
	
	
	self.OpenProgramModal = function() {
		
		var modalInstance = $uibModal.open({
			templateUrl: 'program.html',
			controller: 'ProgramModalCtrl as modal',
			backdrop: 'static',
			keyboard: false,
			resolve: {
				samples: function () {
					return self.sampleArray;
				}
			}
		});

		modalInstance.result.then(function () {
			console.log("modal closed");
		}, function () {
			console.log('Modal dismissed at: ' + new Date());
		});
	}



	self.OpenMsgModal = function(msg) {
		
		var modalInstance = $uibModal.open({
			templateUrl: 'msg.html',
			controller: 'MsgModalCtrl as modal',
			// backdrop: 'static',
			// keyboard: true,
			resolve: {
				msg: function () {
					return msg;
				}
			}
		});

		modalInstance.result.then(function () {
			console.log("modal closed");
		}, function () {
			console.log('Modal dismissed at: ' + new Date());
		});
	}

}

app.controller('MsgModalCtrl', MsgModalCtrl);
function MsgModalCtrl ($scope, $uibModalInstance, msg) {

	var self = this;

	self.title = 'Error'
	self.msg = msg;

	self.Finish = function () {
		$uibModalInstance.close();
	};

	self.Cancel = function () {
		$uibModalInstance.dismiss('cancel');
	};
}


app.controller('ProgramModalCtrl', ProgramModalCtrl);
function ProgramModalCtrl ($scope, $uibModalInstance, programService, samples) {

	var self = this;

	self.state = "connect";

	self.progressMax = 100;
	self.progressValue = 0;

	self.sampleMax = 99;
	self.sampleValue = 0;
	self.sampleName = '';

	self.doneMsg = 'Done!';


	self.UpdateState = function() {
		
		switch(self.state) {
		case "connect" :
			self.title = "Connecting...";
			break;
		case "erase" :
			self.title = "Erasing...";
			break;
		case "program" : 
			self.title = "Programming...";
			break;
		case "done" :
			self.title = "Programming finished.";
			break;
		default :
			break;
		}
	}
	// Run initial state update
	self.UpdateState();

	self.Finish = function () {
		$uibModalInstance.close();
	};

	self.Cancel = function () {
		$uibModalInstance.dismiss('cancel');
	};



	// Try to connect to the Drum Module
	programService.ConnectToDevice(function(err) {
		if(!err) {
			self.UpdateState()
			self.state = 'erase';
			$scope.$applyAsync();

			setTimeout(function() {

				// Start Programming 
				programService.ProgramDevice(samples, function(state, name, progress, overallProgress) {
					self.state = state;
					self.sampleValue = progress.toFixed();
					self.sampleName = name;

					self.progressValue = overallProgress;

					self.UpdateState();
					$scope.$applyAsync();
					
				}, function(err) {
					if(err) {
						self.title = 'Programming failed!'
						self.doneMsg = err;
					} else {
						self.doneMsg = 'Success!'
					}

					// Restart device after programming
					setTimeout(function() {
						programService.RestartDevice(function(err) {
							self.state = 'done';
							$scope.$applyAsync();
						});
					}, 100);
				});

			}, 100);
		}
	});



};