app.directive('esDropZone', ['$window', function($window) {
	return {
		restrict: 'A',
		link: function (scope, element, attrs) {
			
			var cnt = 0;
			
			element.bind('dragenter', function (e) {
				if (cnt == 0) {
					scope.$broadcast('esDropZone::dragenter');
				}
				cnt++;
				e.stopPropagation();
				e.preventDefault();
			});
			element.bind('dragleave', function (e) {
				cnt--;
				if (cnt == 0) {
					scope.$broadcast('esDropZone::dragleave');
				}
				e.stopPropagation();
				e.preventDefault();
			});
			element.bind('dragover', function (e) {	
				e.stopPropagation();
				e.preventDefault();
			});
			element.bind('drop', function (e) {
				
				var items = e.dataTransfer.items;
				scope.$broadcast('esDropZone::drop', items);
				cnt = 0;
				
				e.stopPropagation();
				e.preventDefault();
			});URL.createObjectURL
			
		}
	};
}]);

app.directive('esOverlay', function() {
	return {
		restrict: 'E',
		template: 
		'<div class="es-dropzone" ng-class="style">' +
		'<div class="es-dropzone-text">Drop file or folder with .wav</div>' + 
		'</div>'
		,
		scope: {
			onDrop: '&'
		},
		link: function (scope, element, attrs) {
			
			var dropCallback = scope.onDrop();
			
			scope.style = 'hidden';
			
			scope.$on('esDropZone::dragenter', function() {
				scope.style = '';
				scope.$apply();
				
				console.log('dragenter');
			});
			
			scope.$on('esDropZone::dragleave', function() {
				scope.style = 'hidden';
				scope.$apply();
				
				console.log('dragleave');
			});
			
			scope.$on('esDropZone::drop', function(e, args) {
				scope.style = 'hidden';
				scope.$apply();
				
				// Call callback
				typeof scope.onDrop() === 'function' && dropCallback(args);
			});
			
		}
	};
});